
include:
  - project: 'documents/ci-building-blocks-documents'
    ref: main
    file:
      - '/base.yml'
      - '/build.yml'
      - '/documents-integration.yml'
      - '/publish.yml'
      - '/scan/coverity.yml'
      - '/scan/blackduck.yml'
      - '/scan/spectral.yml'

stages:
  - build
  - test
  - documents-integration
  - publish
  - scan

variables:
  # publish variables
  PROJECT_NAME: cacheservice
  CHART_NAME: core-cacheservice
  PROJECT_VERSION_PART: "8.19"
  REGISTRY: registry.open-xchange.com
  REGISTRY_PROJECT: appsuite-core-internal
  REGISTRY_BASE: registry.open-xchange.com/appsuite-core-internal

  CI_DEBUG_TRACE: "false"

image integrationtest:
  stage: test
  tags:
    - docint
  script:
    - GITLAB_IMAGE=$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
    - CONF_FILE=$CI_PROJECT_DIR/cacheservice.properties
    - cat $ITEST_CONFIG | base64 -d > $CONF_FILE
    - DB_HOST=$(sed -n -E 's/.*database.host\s*=\s*([0-9\.]+)/\1/p' cacheservice.properties)
    - DB_USER=$(sed -n -E 's/.*database.user\s*=\s*([a-zA-Z0-9\.]+)/\1/p' cacheservice.properties)
    - DB_PASSWORD=$(sed -n -E 's/.*database.password\s*=\s*([a-zA-Z0-9\.]+)/\1/p' cacheservice.properties)
    # the export is needed because in the cacheservice as SystemEnv is read out
    - export SERVER_PORT=$(echo $(((RANDOM % 1000 ) + 24000)))
    - CS_TEST_NAME=csintegrationtest$SERVER_PORT
    - sed -i -E "s/schema=CHANGE_ME/schema=$CS_TEST_NAME/g" $CONF_FILE
    - sed -i -E "s/bucketName=CHANGE_ME/bucketName=$CS_TEST_NAME/g" $CONF_FILE
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY_IMAGE
    - docker run -d -it --name $CS_TEST_NAME -p $SERVER_PORT:8001 --pull=always --mount type=bind,source=$CONF_FILE,target=/opt/open-xchange/cacheservice/etc/cacheservice.properties $GITLAB_IMAGE
    - ITEST_STATUS=$(./gradlew test:integration)
    - docker logs $CS_TEST_NAME
    - echo $ITEST_STATUS
    - docker stop $CS_TEST_NAME
    - docker container rm -f $CS_TEST_NAME
    - mysql -h $DB_HOST -u $DB_USER -p$DB_PASSWORD -e "DROP DATABASE $CS_TEST_NAME"
    - FAILURE_COUNT_TOTAL=0
    - for entry in ./test/build/test-results/integration/TEST-*.xml; do FAILURE_COUNT=$(xq -x /testsuite/@failures $entry); FAILURE_COUNT_TOTAL=$((FAILURE_COUNT_TOTAL+FAILURE_COUNT)); done
    - echo "Image integration test finished with $FAILURE_COUNT_TOTAL failures"
    - if [[ $FAILURE_COUNT_TOTAL -gt 0 ]]; then exit 1; fi
  artifacts:
    when: always
    reports:
      junit: test/build/test-results/integration/TEST-*.xml
    paths:
      - test/build/test-results/integration/TEST-*.xml
  rules:
    - allow_failure: false
    - changes:
        - src/**/*
        - test/**/*
        - Dockerfile
        - .gitlab-ci.yml

blackduck scan:
  extends: .blackduck-docs
  variables:
    BLACKDUCK_PROJECT_NAME: "Product: OX Documents Cacheservice"
    BLACKDUCK_PROJECT_VERSION_NAME: "$CI_COMMIT_REF_NAME source"

coverity scan:
  extends: .coverity-docs
  variables:
    COV_STREAM_NAME: documents_cacheservice
  before_script:
    - cov-build --dir coverity_test ./gradlew clean build -x test -x integration
